﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Evaluant.PS4VS.Language.Expressions
{
    public class CmdletCall : IAAST
    {
        public CmdletCall(string cmdletName, IAAST parameters)
        {
            this.CmdletName = cmdletName;
            Parameters = (Parameters)parameters;
        }

        public string CmdletName { get; set; }

        public IList<Parameter> Parameters { get; set; }

        #region IAAST Members

        public ExpressionType ExpressionType
        {
            get { return ExpressionType.CmdletCall; }
        }

        #endregion
    }
}
