﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;
using Evaluant.PS4VS.Language.Expressions;
using Microsoft.VisualStudio.TextManager.Interop;
using Babel.ParserGenerator;

namespace Evaluant.PS4VS.Parser
{
    public partial class Parser
    {
        public IAAST Aast { get; set; }

        StringCollection variables = new StringCollection();

        public IAAST RegisterVariable(string variableName)
        {
            return new Variable(variableName);
        }

        private TextSpan TextSpan(LexLocation location)
        {
            return MkTSpan(location);
        }
    }
}
